﻿using UnityEngine;
using System.Collections;

public class PersonIA : MonoBehaviour {

    private Rigidbody m_rigidThis;
    private Transform m_transThis;
    public Renderer[] m_renderChilds;
    public float m_speed;
    public enum PersonState { Normal=0, Hoping, InLove, Broken };
    public PersonState m_ePersonState;
    public Material m_matBroken;
    public Material m_matLove;
    public static int s_iNbRelation = 0, s_iNbBroken = 0;
	// Use this for initialization
	void Start () {

        m_rigidThis = rigidbody;
        m_transThis = transform;
	}
	
	// Update is called once per frame
	void FixedUpdate () 
    {
        float distanceFromPlayer = Vector3.Distance(m_transThis.position,PlayerController.TransThis.position);
        if (Manager.GameEnd) m_ePersonState = PersonState.Broken;
        if (PlayerPawn.IsUmbrellaDeployed)
        {
                if (distanceFromPlayer < PlayerPawn.s_fSelfEsteem/2)
                {
                    //Debug.Log("m_ePersonState_" + m_ePersonState + "_" + PersonState.Hoping);

                    if (m_ePersonState == PersonState.Normal)
                    {
                        startHoping();
                    }
                    if (m_ePersonState != PersonState.Broken || m_ePersonState == PersonState.InLove)
                    {
                        moveTowardPlayer();
                    }
                }
                else
                {
                    if (m_ePersonState == PersonState.Hoping)
                    {
                        endHoping();
                    }

                    if (m_ePersonState == PersonState.InLove)
                    {
                        endRelationship();
                    }
                }
        }
        else
        {
            if (m_ePersonState == PersonState.InLove)
            {
                endRelationship();
            }
        }
	}

    private void moveTowardPlayer()
    {
        Vector3 v3TowardPlayer = PlayerController.TransThis.position - m_transThis.position;
        m_rigidThis.AddForce(v3TowardPlayer * m_speed, ForceMode.Force);
    }
   
    public void startHoping()
    {
        m_ePersonState = PersonState.Hoping;
        //Debug.Log("START_" + m_ePersonState);
    }

    public void endHoping()
    {
        m_ePersonState = PersonState.Broken;
        //Debug.Log("ENDRelationship_" + m_ePersonState);
        changeMaterial(m_matBroken);
        s_iNbBroken++;
    }

    public void startRelationship()
    {
        m_ePersonState = PersonState.InLove;
        //Debug.Log("START_" + m_ePersonState);
        changeMaterial(m_matLove);
        s_iNbRelation++;
    }

    public void endRelationship()
    {
        m_ePersonState = PersonState.Broken;
        //Debug.Log("ENDRelationship_" + m_ePersonState);
        changeMaterial(m_matBroken);
        PlayerPawn.S_IALover = null;
        s_iNbBroken++;
    }

    public void changeMaterial(Material _mat)
    {
        for (int i = 0; i < m_renderChilds.Length; i++)
        {
            //Debug.Log("changeMaterial_"+i);
            //m_renderChilds[i].material = _mat;
            StartCoroutine(m_renderChilds[i].ColorTo(_mat.color,1f,Ease.Linear));
        }
    }

}
