﻿using UnityEngine;
using System.Collections;

public class PlayerPawn : MonoBehaviour {

    public enum PlayerState { Down, Normal, InLove, TrueLove };
    private PlayerState m_ePlayerState;
    private static PersonIA s_IALover;
    private static bool dinw = false;
    public static PersonIA S_IALover
    {
        get { return PlayerPawn.s_IALover; }
        set { PlayerPawn.s_IALover = value; if (value == null) dinw = true; }
    }
    public TriggerConstantForce m_forceField;

    public float m_fMaxSelfEsteem;
    public static float s_fSelfEsteem;
    public float m_fNbDropCuts;
    private float m_fCut;
    private bool m_bDropHit;
    public float m_fDropSpacing; //Time between 2 Drops
    public GameObject m_gobjEsteemArea;
    private Transform m_transEsteemArea;
    private Renderer m_renderEsteemArea;
    public Renderer[] m_renderChilds;

    public GameObject m_gobjUmbrella;
    private Transform m_transUmbrella;
    private Vector3 m_posUmbrellaInit, m_scaleUmbrellaInit;
    private static bool s_bIsUmbrellaDeployed = true;
    public static bool IsUmbrellaDeployed
    {
        get { return s_bIsUmbrellaDeployed; }
    }
    private bool isUmbrellaAvailable = true;
    public TextMesh m_text, m_text2;
    public float m_fDeploySpeed;
    private Color m_colorCutEsteemArea;
    public Material m_matDropHit, m_matNormal, m_matTrueLove;
    
	// Use this for initialization
	void Start () {
        s_IALover = null;
        s_fSelfEsteem = m_fMaxSelfEsteem;
        m_ePlayerState = PlayerState.Normal;
        m_transEsteemArea = m_gobjEsteemArea.transform;
        m_renderEsteemArea = m_gobjEsteemArea.renderer;
        m_transUmbrella = m_gobjUmbrella.transform;
        m_posUmbrellaInit = m_transUmbrella.position;
        m_scaleUmbrellaInit = m_transUmbrella.localScale;
       // Umbrella(true);
        m_fCut = m_fMaxSelfEsteem / m_fNbDropCuts;
        //m_matNormal = m_renderEsteemArea.material;
        m_colorCutEsteemArea = m_matNormal.color.ColorCutTo(m_matDropHit.color, 1);
	}
	
	
	void Update () {
        /*if (dinw)
        {
            //Umbrella(false);
            Debug.Log("Dinw");
            dinw = false;
        }*/
        if (Input.GetKeyDown(KeyCode.Space))
        {
            if (!Manager.GameEnd)
            {
                Umbrella(!s_bIsUmbrellaDeployed);//Debug.Log("Input Space");
            }
            else Application.LoadLevel(Application.loadedLevel);
        }
	
	}

    void OnTriggerEnter(Collider other)
    {
        //Debug.Log(other.tag);
        if (m_ePlayerState != PlayerState.TrueLove)
        {
            #region ONE
            if (other.tag == "One")
            {
                m_ePlayerState = PlayerState.InLove; //Find the true love.
                m_fMaxSelfEsteem = m_fMaxSelfEsteem * 3;
                Destroy(m_forceField.gameObject);
                //m_forceField.enabled = false;
                PlayerController.m_rigidThis.velocity = Vector3.zero;
                Manager.GameEnd = true;
                //Launch cinematic
                m_text.text = "What a love life! You've broken " + PersonIA.s_iNbBroken + " hearts...";
                m_text2.text = " And in the end you get only one but the only one true love.";
            }
            #endregion

            #region Person
            if (other.tag == "Person")
            {
                if (s_IALover == null && s_bIsUmbrellaDeployed)
                {

                    //Person
                    PersonIA person = other.gameObject.GetComponent<PersonIA>();
                    if (person.m_ePersonState <= PersonIA.PersonState.Hoping)
                    {
                        //Player
                        StartCoroutine(RestoreEsteem(m_fDropSpacing));
                        person.startRelationship();
                        s_IALover = person;
                    }
                }
            }
            #endregion

            #region Drop
            if (other.tag == "Drop" && Manager.GameStarted)
            {

                //Destroy(other.gameObject);//Pool it or restart it.

                if (m_ePlayerState < PlayerState.InLove)
                {
                    if (!s_bIsUmbrellaDeployed)
                    {
                        StartCoroutine(WaitBetweenDropHit(m_fDropSpacing));
                    }
                }

            }
            #endregion
        }
    }
    
    IEnumerator WaitBetweenDropHit(float _duration)
    {
        
        if (!m_bDropHit)
        {
            m_bDropHit = true;
            Debug.Log("DropHit_ " + s_fSelfEsteem + " -" + m_fCut);
            
            if (m_ePlayerState > PlayerState.Down)
            {
                Debug.Log("m_ePlayerStateIN" + m_ePlayerState);
                s_fSelfEsteem = Mathf.Max(0, s_fSelfEsteem - m_fCut);
                Color _color = m_renderEsteemArea.material.color - m_colorCutEsteemArea;
                StartCoroutine(m_renderEsteemArea.ColorTo(_color, 1f, Ease.Linear));
                yield return StartCoroutine(m_transEsteemArea.ScaleTo(new Vector3(s_fSelfEsteem, m_transEsteemArea.localScale.y, s_fSelfEsteem), _duration, Ease.BackInOut));

                if (s_fSelfEsteem == 0)
                {
                    m_ePlayerState = PlayerState.Down;
                }
            }
            //Debug.Log("m_ePlayerStateOUT" + m_ePlayerState);
            m_bDropHit = false;
        }
        

    }

    IEnumerator RestoreEsteem(float _duration)
    {

        m_ePlayerState = PlayerState.InLove;
        s_fSelfEsteem = m_fMaxSelfEsteem;
        /*yield return */StartCoroutine(m_transEsteemArea.ScaleTo(new Vector3(s_fSelfEsteem, m_transEsteemArea.localScale.y, s_fSelfEsteem), _duration, Ease.BackInOut));
        yield return StartCoroutine(m_renderEsteemArea.ColorTo(m_matNormal.color, _duration, Ease.Linear));


    }

    /*public void changeColor(Renderer _rend, Color _color)
    {
        StartCoroutine(_rend.ColorTo(_color, 1f, Ease.Linear));
    }*/

    /*public void changeColorInChilds(Color _color)
    {
        for (int i = 0; i < m_renderChilds.Length; i++)
        {
            StartCoroutine(m_renderChilds[i].ColorTo(_color, 1f, Ease.Linear));
        }
    }*/

    public void Umbrella(bool _bDeploy)
    {
        //m_gobjUmbrella.SetActive(_bDeploy);
       // m_gobjUmbrella.animation.
        StartCoroutine(DeployUmbrella(_bDeploy, m_fDeploySpeed));
        
    }

    IEnumerator DeployUmbrella(bool _bDeploy, float _duration)
    {
        if (isUmbrellaAvailable)
        {
            isUmbrellaAvailable = false;

            if (_bDeploy)
            {
                yield return StartCoroutine(m_transUmbrella.ScaleTo(m_scaleUmbrellaInit, _duration/2, Ease.BackOut));
                yield return StartCoroutine(m_transUmbrella.MoveTo(m_posUmbrellaInit, _duration, Ease.BackOut));
                
                
            }
            else
            {
                yield return StartCoroutine(m_transUmbrella.MoveTo(new Vector3(m_posUmbrellaInit.x+0.5f,m_posUmbrellaInit.y,m_posUmbrellaInit.z+0.12f), _duration, Ease.BackIn));
                yield return StartCoroutine(m_transUmbrella.ScaleTo(new Vector3(0, 1.5f, 0), _duration/2, Ease.BackIn));
            }

            

            if (!s_bIsUmbrellaDeployed && m_ePlayerState < PlayerState.TrueLove)
            {
                m_ePlayerState = PlayerState.Normal;
            }

            s_bIsUmbrellaDeployed = _bDeploy;

            //Debug.Log("Deployed" + s_bIsUmbrellaDeployed);

            isUmbrellaAvailable = true;
        }
    }
}
